%{
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "asterisk/logger.h"
#include "argdesc.tab.h"
#include "asterisk/argdesc.h"
struct argapp *argdesc_parse(char *filename, int *errors);
int argdesc_my_lineno = 1;
int argdesc_my_col = 0;
int argdesc_yyget_column  (yyscan_t yyscanner);
void argdesc_yyset_column (int  column_no , yyscan_t yyscanner);
int argdesc_yyparse (void *);
%}
%option prefix="argdesc_yy"
%option batch
%option outfile="argdesc_lex.c"
%option reentrant
%option bison-bridge
%option bison-locations
%option yylineno
%option noyywrap

%%
\{	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return LC;}
\}	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return RC;}
\(	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return LP;}
\)	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return RP;}
\[	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return LB;}
\]	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return RB;}
\<	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return LAB;}
\>	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return RAB;}
\;	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return SEMI;}
\=	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return EQ;}
\,	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return COMMA;}
\:	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return COLON;}
\|	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return BAR;}
\.\.\. {yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return ELLIPSES;}
options	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return KW_OPTIONS;}
args	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return KW_ARGS;}
Chanvars	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return KW_CHANVARS;}

\"[^"]*\"	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno;yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col; yylval->str = strdup(yytext);argdesc_my_col+=yyleng; return str1;}
[-A-Za-z0-9_&/?]*	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno;yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col; yylval->str = strdup(yytext);argdesc_my_col+=yyleng; return word;}

\#i	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return intspec;}
\#f	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return fltspec;}
\#s	{yylloc->first_line = yylloc->last_line = argdesc_my_lineno; yylloc->last_column=argdesc_my_col+yyleng-1; yylloc->first_column=argdesc_my_col;argdesc_my_col+=yyleng;return strspec;}

\n		{argdesc_my_lineno++;argdesc_my_col=0;}
[ ]+	{/* nothing */ argdesc_my_col+=yyleng;}
[	]+	{/* nothing */ int wid = 8-(argdesc_my_col%8); argdesc_my_col+=wid;}

%%

struct argapp *argdesc_parse(char *filename, int *errors)
{
	struct argapp *apps;
	struct parse_arginfo *io;
	FILE *fin;
	io = calloc(sizeof(struct parse_arginfo),1);
	fin = fopen(filename,"r");
	if (!fin) {
		ast_log(LOG_ERROR,"File %s could not be opened\n", filename);
		free(io);        
		return 0;
	}
	argdesc_yylex_init(&io->scanner);
	
	/* other way argdesc_yy_scan_string (buffer ,io->scanner); */

	argdesc_yyset_in (fin , io->scanner);

	argdesc_yyparse ((void *) io);

	fclose(fin);

	apps = io->apps;
	*errors = io->syntax_error_count;

	argdesc_yylex_destroy(io->scanner);

	free(io);

	return apps;
}

